VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Simple Vector Collision Detection"
   ClientHeight    =   1635
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4125
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1635
   ScaleWidth      =   4125
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   3600
      Top             =   840
   End
   Begin VB.Shape Shape1 
      Height          =   135
      Left            =   3120
      Shape           =   3  'Circle
      Top             =   120
      Width           =   135
   End
   Begin VB.Line Line1 
      Index           =   7
      X1              =   3840
      X2              =   4680
      Y1              =   2400
      Y2              =   2640
   End
   Begin VB.Line Line1 
      Index           =   6
      X1              =   3240
      X2              =   3840
      Y1              =   2520
      Y2              =   2400
   End
   Begin VB.Line Line1 
      Index           =   5
      X1              =   960
      X2              =   1560
      Y1              =   2760
      Y2              =   2400
   End
   Begin VB.Line Line1 
      Index           =   4
      X1              =   2280
      X2              =   2640
      Y1              =   2520
      Y2              =   2880
   End
   Begin VB.Line Line1 
      Index           =   3
      X1              =   1560
      X2              =   2280
      Y1              =   2400
      Y2              =   2520
   End
   Begin VB.Line Line1 
      Index           =   2
      X1              =   2640
      X2              =   3240
      Y1              =   2880
      Y2              =   2520
   End
   Begin VB.Line Line1 
      Index           =   1
      X1              =   480
      X2              =   960
      Y1              =   2640
      Y2              =   2760
   End
   Begin VB.Line Line1 
      Index           =   0
      X1              =   0
      X2              =   480
      Y1              =   2400
      Y2              =   2640
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Ang As Integer
Dim pi As Double
Dim Px1 As Integer
Dim Py1 As Integer
Dim Px2 As Integer
Dim Py2 As Integer
Dim Grad As Double
Dim BallSpeed As Double


Private Sub Form_Load()
    Ang = 70    'Angle of ball
    pi = 3.141592654
    BallSpeed = 30 'Speed of ball
    For i = 0 To 6  'Spread lines out along form
        Line1(i).X1 = (6000 * i / 6) - 1000
        Line1(i).X2 = (6000 * (i + 1) / 6) - 1000
    Next
    
    For i = 0 To 6  'Create initial sine curve
        Line1(i).Y1 = Form1.Height - 1000 - Sin(Line1(i).X1) * 400
        Line1(i).Y2 = Form1.Height - 1000 - Sin(Line1(i).X2) * 400
    Next
    
End Sub

Private Sub Timer1_Timer()


    Shape1.Left = Shape1.Left + Cos(Ang * (pi / 180)) * BallSpeed ' Move ball
    Shape1.Top = Shape1.Top + Sin(Ang * (pi / 180)) * BallSpeed ' Move ball
    If Shape1.Left < 0 Then Ang = 180 - Ang ' Bounce off left border
    If Shape1.Left + Shape1.Width > Form1.Width Then Ang = 180 - Ang  ' Bounce off right border
    If Shape1.Top < 0 Then Ang = 360 - Ang ' Bounce off top border
    
    For i = 0 To 7  'Detect collision and change angle of ball
        Px1 = Line1(i).X1  ' Assign line values to variables
        Py1 = Line1(i).Y1
        Px2 = Line1(i).X2
        Py2 = Line1(i).Y2
        
        Grad = (Py1 - Py2) / (Px1 - Px2) 'Determine gradient of current line
        
        ' If ball is over lines first x value and less than lines second value
        ' and ball is lower than position on line (Shape1.Top + Shape1.Height > Grad * (Shape1.Left - Px1) + Py1) then
        If Shape1.Left > Px1 And Shape1.Left < Px2 And Shape1.Top + Shape1.Height > Grad * (Shape1.Left - Px1) + Py1 Then
            Ang = 360 - (Ang - Atn(Grad) / (pi / 180)) ' Change direction of ball
            Shape1.Top = Grad * (Shape1.Left - Px1) + Py1 - Shape1.Height 'Put ball where it should be (on line)
        End If
    Next
    
    For i = 0 To 6
        Line1(i).X1 = Line1(i).X1 - 1 ' Move line to the left
        Line1(i).X2 = Line1(i).X2 - 1
        If Line1(i).X2 < 0 - 1000 Then ' If its to far left move it back to the right
            difference = Line1(i).X1 - Line1(i).X2
            Line1(i).X1 = 6000 + (6000 / 6) - 1000
            Line1(i).X2 = Line1(i).X1 + difference
        End If
    Next
    
    For i = 0 To 6 ' Calculate new sine graph
        Line1(i).Y1 = Form1.Height - 1000 - Sin(Line1(i).X1 * (pi / 180)) * 400
        Line1(i).Y2 = Form1.Height - 1000 - Sin(Line1(i).X2 * (pi / 180)) * 400
    Next
    
End Sub
